//Julia-Menge zu z -> z - f(z)/f'(z)  mit f(z) = z^7-3z^3+c 
//Mit Tasten <1>...<6> wählt man das gewünschte Bild
//1: JuliaNewton, 2: JuliaNewton mit schwarzer JM, 3:JuliaNewton mit 9-Kreise Traps
//4: JuliaMenge mit 9-Kreise Traps und schwarzem Hintergrund
//5: JuliaMenge schwarz/weiß, 6: JuliaMenge Konvergenzbild
//Linksklick zoomen an angeklickte Stelle
//Taste <c> wählt einen zufälligen c-Wert, Taste <n> zeichnet die verschiebenfarbigen Fatou-Gebiete
//Fünf Attraktoren (Fixpunkte) - Grad 5
//Weitere Informationen:  https://ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<Threads> threads;
Complex zNeu,zAlt,z,z0,z1,C,zA,zB,zfZaehlerNewton,zF;
ArrayList<Complex> fixpunkte;
FarbTafel farben;
double zR,zI;
double xU = -1.8; 
double yU = -1.8; 
double xO = 1.8;
double yO = 1.8;
double zoomFaktor=1;
double wh = xO-xU;
double x0,y0;
double laenge;
double a,b; //Fixpunkte
float aP,bP;//...und ihre Koordinaten
boolean FPzeichnen = false;
boolean farbig = false;//Unterscheidung verschiedener Orbitpunkte
boolean orbitZeichnen = false;
boolean cWerteEintragen= true; 
int Selektor;
int maxiterations = 500;//Iterationsgrenze 
int anzahlFixpunkte = 7; //entspricht dem Grad des ganzrationalen Iterations-Polynoms der Form z^n+c
int maxFPIteration = 50*anzahlFixpunkte;//Iterationsgrenze beim Suchen der Fixpunkte. Je mehr Fixpunkte desto höher wählen
int orbitZeichnenAb ;
int orbitZeichnenBis;
int punktGroesse;
double massFuerUnendlich = 10000;
double e = 0.0001; //Abstand, ab dem der Orbitpunkt als zugehöriger Fixpunkt gilt
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 

color farbe;
boolean gelbC;
float fxMax,fxMin,fyMax,fyMin;//Maxima und Minima der x bzw y Werte der Fixpunkte

void setup() {
  background(255); 
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  fixpunkte = new ArrayList<Complex>();
  fxMin = fyMin =  10;//Minima und Maxima der Fixpunkte
  fxMax = fyMax = -10;//bzgl Realteil und Imaginärteil
  farben= new FarbTafel();
  farben.farbTafelErzeugen();
  size(800, 800);
  //c-Wert
  x0=-0.3; y0=0.5;//Julia-Menge nach DEM und BSM nur bei (1,0), (0,1), ...zu sehen! Warum?
  C = new Complex(x0,y0);
  z0 = new Complex(0,0);
  Selektor = 1;
  if(zoomFaktor ==1){
        fixPunkteBestimmen();
        fxMin = fxMinBestimmen();
        fxMax = fxMaxBestimmen();
        fyMin = fyMinBestimmen();
        fyMax = fyMaxBestimmen();
      }
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                Selektor, e, fxMin, fxMax, fyMin, fyMax, fixpunkte); 
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, double X0, double Y0, 
                   int selektor, double e,  float fxMin, float fxMax, float fyMin, float fyMax, ArrayList<Complex> fixpunkte){
  
  xU = px; yU = py;
  x0 = X0; y0 = Y0;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  Selektor = selektor;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,
                        selektor, e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(200);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0)println("fertig!");
       noLoop();
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);  
  }  
  
  if(orbitZeichnen){
      juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis );
      orbitZeichnen = false;
      farbig = false;
  }
  
  if(FPzeichnen){
    println("Fixpunkte eintragen");
    fixPunkteBestimmen();
    for(int l =0; l<anzahlFixpunkte;l++){
      fixPunktEintragen(fixpunkte.get(l));
    }
    FPzeichnen = false;
  }
  
  if(cWerteEintragen){  
    if(gelbC){
        punktGroesse = 6;
        color f1 = color(255,255,0);
        color f2 = f1;        
        zA =  new Complex(1,0);
        zB =  new Complex(0,1);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);        
    }
 }       
}
///////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){ 
  //Zunächst alle vorhandenen Punkte löschen
  fixpunkte = new ArrayList<Complex>();
  zF = startWertFP();  
  fixpunkte.add(zF);
  println("Fixpunkt 1: "+fixpunkte.get(0));  
  for(int j =1; j<anzahlFixpunkte; j++){
    zF = startWertFP();
    while(naeheTestenMit(j)){
      zF = startWertFP();
    }
    fixpunkte.add(zF);
    println("Fixpunkt "+(j+1)+": "+fixpunkte.get(j));
  }
}
//////////////////////////////////////////////////////////
Complex startWertFP(){
  
  zR = random(-1.5,1.5); zI = random(-1.5,1.5);
  zAlt =new Complex(zR,zI); //Startwert
  zF = FPNewton(zAlt,maxFPIteration); 
  return zF; 
}
////////////////////////////////////////////////////////////////
boolean naeheTestenMit(int j){
  
    boolean zuNahTest = false;  
    boolean[] zuNah;
    zuNah = new boolean[j];  
    for(int i=0; i<j; i++){
      zuNah[i] = (zF.subtractC(fixpunkte.get(i))).getLength() < 0.00001;
      zuNahTest = zuNahTest || zuNah[i];
    }  
    return zuNahTest;
  }
///////////////////////////////////////////////////////////////
void fixPunktEintragen(Complex Z1 ){  
  
  strokeWeight(8); 
  stroke(255);
  a = Z1.getRealPart();
  b = Z1.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
}
////////////////////////////////////////////////////////////////////////////////
float fxMinBestimmen(){//bestimmt den minimalen realen Wert der Fixpunkte
  float fxMi = 10;
  for(Complex f: fixpunkte){
    if(f.getRealPart()<fxMi) fxMi = (float)f.getRealPart(); 
  }
  return fxMi;
}
//////////////////////////////////////////////////////////////////////////////////
float fxMaxBestimmen(){//bestimmt den maximalen realen Wert der Fixpunkte
  float fxMa = -10;
  for(Complex f: fixpunkte){
    if(f.getRealPart()>fxMa) fxMa = (float)f.getRealPart(); 
  }
  return fxMa;
}
////////////////////////////////////////////////////////////////////////////////
float fyMinBestimmen(){//bestimmt den minimalen imaginären Wert der Fixpunkte
  float fyMi = 10;
  for(Complex f: fixpunkte){
    if(f.getImaginaryPart()<fyMi) fyMi = (float)f.getImaginaryPart();
  }
  return fyMi;
}
//////////////////////////////////////////////////////////////////////////////////
float fyMaxBestimmen(){//bestimmt den maximalen realen Wert der Fixpunkte
  float fyMa = -10;
  for(Complex f: fixpunkte){
    if(f.getImaginaryPart()>fyMa) fyMa = (float)f.getImaginaryPart(); 
  }
  return fyMa;
}
///////////////////////////////////////////////////////////////
void punkteEintragen(Complex Z1, Complex Z2, color farbe1, color farbe2, int punktGroesse){
  
  strokeWeight(punktGroesse);   
  //Fixpunkt (abstoßend) auf Julia-Menge oder spezieller c-Wert
  stroke(farbe1);
  aP = map((float)Z1.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z1.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP);  
  //Fixpunkt (anziehend) in Gefangenen-Menge  oder spezieller c-Wert
  stroke(farbe2);
  aP = map((float)Z2.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z2.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP);
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M, int N) {//...um einen Orbit zu zeichnen ..ab ..bis
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);
  if(farbig) {
     colorMode(HSB,255,255,255);
     farbe = color(random(0,255),255,255);
     stroke(farbe);
     
   }else{
      stroke(0,255,0);
      colorMode(RGB, 255,255,255);
    }   
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  strokeWeight(punktGroesse+2);
  point(aP,bP);
  
  while (n < N) {
    zNeu = FPNewton(zAlt,1);   
    laenge = zNeu.getLength();
    if (laenge > massFuerUnendlich) {
      break; 
    }
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > M){         
      aP = map((float)a,(float)xU,(float)xO,0,width);
      bP = map((float)b,(float)yU,(float)yO,height,0);
      if(farbig) stroke(farbe);
        else stroke(255,0,0);
      strokeWeight(punktGroesse);
      point(aP,bP);
    }
    zAlt = new Complex(a,b);
    n++; 
  }
  colorMode(RGB);
  return n;
 }
////////////////////////////////////////////////////////////////////
 Complex FPNewton(Complex zAlt, int M){//Newton-Iteration 
 
   for(int i =0; i< M;i++){
      zNeu = f(zAlt,C).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;//println(zAlt);
   }
  return zAlt;
 }
 Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(7);//z^7
      zaehler = zaehler.addC(C);//z^7+c 
      zaehler = zaehler.subtractC((zAlt.power(3)).multiply(3));//z^7-3z^3+c 
      zaehler = zaehler.multiply(-1);
      return zaehler;
 }
 Complex fS(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt.power(6);//z^6
      nenner = nenner.multiply(7);//7z^6
      nenner = nenner.subtractC((zAlt.power(2)).multiply(9));
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
////////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
         
      if (mouseButton == LEFT){ //Angeklickte Stelle zoomen
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          e = e/2;//epsilon
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, 
                        Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);  
          redraw();
        
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 20;
          punktGroesse =4;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen von Beginn");
          redraw();
         
     }else if (keyPressed == false){ //Orbit ab Element orbitZeichnenAb einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb  = 1000;
          orbitZeichnenBis = 1100;
          punktGroesse =4;   
          farbig = false;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = "+ orbitZeichnenAb);
          redraw();
     }
 }  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
 
  if (key == 'c'){
      println("Zufälligen C-Wert wählen");
      x0=random(-2,2); y0=random(-2,2);//C-Wert
      C = new Complex(x0,y0);
      if(zoomFaktor ==1){
        fixPunkteBestimmen();
        fxMin = fxMinBestimmen();
        fxMax = fxMaxBestimmen();
        fyMin = fyMinBestimmen();
        fyMax = fyMaxBestimmen();
      }
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }
  
   if (key == 'f'){//Fixpunkte einzeichnen
     FPzeichnen=true;
     redraw();
  }
    
  if (key == '1'){//Fatou-Gebiete farbig einzeichnen
      nummerThread =0;
      println("Newton-Bereiche eintragen");
      Selektor = 1; 
      if(zoomFaktor ==1){
        fixPunkteBestimmen();
        fxMin = fxMinBestimmen();
        fxMax = fxMaxBestimmen();
        fyMin = fyMinBestimmen();
        fyMax = fyMaxBestimmen();
      }
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }   
  
  if (key == '2'){//nur die Stellen schwarz zeichnen unter denen sich die Julia-Menge bkkefindet  
      nummerThread =0;
      println("Julia-Menge lokalisieren.");
      Selektor = 2;     
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
  
   if (key == '3'){//Fatou-Gebiete farbig einzeichnen und Julia-Menge mit 9-Kreise-Traps
      nummerThread =0;
      println("Fatou-Gebiete farbig und Julia-Newton Fraktal mit Traps");
      Selektor = 3;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
  
  if (key == '4'){//Fatou-Gebiete schwarz-weiß und Julia-Newton Fraktal mit Traps
      nummerThread =0;
      println("Fatou-Gebiete schwarz-weiß und Julia-Newton Fraktal mit Traps");
      Selektor = 4;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  } 
  
  if (key == '5'){//Julia-Menge weiß auf schwarzem Hintergrund
      nummerThread =0;
      println("Julia-Menge weiß auf schwarzem Hintergrund");
      Selektor = 5;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
  
  if (key == '6'){//Julia-Menge Konvergenzgeschwindigkeit
      nummerThread =0;
      println("JJulia-Menge Konvergenzgeschwindigkeit");
      Selektor = 6;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
     
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     maxiterations *= 2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      maxiterations /= 2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);  
  }
//Die folgenden Aktionen betreffen zoomen und verschieben des Bildes//////////////////////////////// 
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  ///Bild speichern/////////////////////////////////////////////////////////////////////////
  if (key == 's') save("julia.png");
  redraw();
}
