//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,C,c,z0,D, zNeuN,zAltN;
  ArrayList<Complex> Fixpunkte;
  int AnzahlFixpunkte;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int anzahlItNewton;
  int tN;
  int selektor;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  int zaehlen;
  double aQMax =0;
  int farbIndex =0;
  double laenge,abstand;
  double x0 ;
  double y0 ;
  double r,R,rM;
  boolean trapped;
  double mR,mI;
  Complex [] MP;
  int j;
  double epsilon ;
  float fxMin, fxMax, fyMin, fyMax;
  String s;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, 
                 int nummer, double X0, double Y0, int Selektor, double e, float FxMin, 
                 float FxMax, float FyMin, float FyMax, ArrayList<Complex> fixpunkte) {
    // benötigte Parameter
    epsilon =e;
    Fixpunkte = fixpunkte;
    AnzahlFixpunkte = fixpunkte.size();
    selektor = Selektor;
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    x0 = X0; y0 = Y0;
    fxMin = FxMin; fxMax = FxMax;
    fyMin = FyMin; fyMax = FyMax;
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    anzahlItNewton = 20; //Anzahl der Iterationschritte für das Konvergenz-Geschwindigkeitsbild
    colorMode(HSB,256,256,256);
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
    zaehlen =0;
    int[][] Rand = new int[width][height/anzahlThreads];
    for (int j =0; j < height/anzahlThreads; j++) {  
      for (int i = 0; i < width; i++) {
         Rand[i][j]=0;
      }
    }
    r=0.20;//Radius der 8 Kreise außen
    rM = 0.24;//Radius des Kreises bei Null
    R=r/Math.sin(Math.PI/8);
    MP = new Complex [8];
    for (int i =0; i<8; i++){
      mR = R*Math.cos(i*Math.PI/4);
      mI = R*Math.sin(i*Math.PI/4);
      MP[i] = new Complex(mR,mI);//if (tN ==8)println(MP[i]);
    }
  }
////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
public void run() {
    
  switch(selektor){
    case 1: 
      bild1();
      break;
    case 2:
      bild2();
      break;
    case 3:
      bild3();
      break;
    case 4:
      bild4();
      break;
    case 5:
      bild5();
      break;
    case 6:
      bild6();
      break;
    
  }
   
  }
///////////////////////////////////////////////////////////////////
color newtonJuliaKonvergenz(Complex Z0){//Fatou-Bereiche werden nur bzg. Konvergenzgeschwindigkeit gefärbt
    color rueckgabe = color(0);
    int n = 0;
    zAlt = Z0;
    while(n < anzahlItNewton  ){
    zNeu = FPNewton10(zAlt); 
    if((zNeu.subtractC(zAlt)).getLength() < 1e-20){      
         break;
      }
      zAlt = zNeu;//if(tN==7) println(n,zAlt);
      n++;
    }    
    rueckgabe = color(140,255,5*n*n);
    return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color newtonJuliaTrap(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    trapped = false;
    zAlt = Z0;
  
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = FPNewton(zAlt); 
      abstand =(zNeu.subtractC(zAlt)).getLength();
      laenge = zNeu.getLength();
   
      //9 Kreise als "Traps" verwenden
      if ((R-r<laenge && laenge <R+r && n >0) || laenge < rM){ //n > 0, weil Abbildung = Id nicht erlaubt ist
         j=0; 
         double a=0;
         //8 Kreise
         while(j < 8){         
           a = MP[j].subtractC(zNeu).getLength();
           
           //trifft einen der 8 Kreise 
           if (a < r){
              trapped = true;
              int fWert = (int)(256*a);
              if (fWert > 127) fWert =127;
              if (fWert <0) fWert =0;
              n = j*128+fWert;    
           }      
           j++;
         }
         //Kreis im Urprung
         if(laenge<rM){
              trapped = true;
              int fWert = (int)(256*laenge);
              if (fWert > 127) fWert =127;
              if (fWert <0) fWert =0;
              n = j*128+fWert; 
         }
         //Je nachdem in welcher Falle gefangen wird die Farbe ausgewählt
         if(trapped == true) {
             farbIndex = n % 1152;
             farbe = farben.farben8Kreise[farbIndex];
             rueckgabe = farbe;
           break;      
         }
      }
      if(selektor ==4){
        rueckgabe = color(0);//Fatougebiete schwarz
      }
      else if(abstand <1e-10){
        float H = (float)zNeu.getAngle();//funktioniert nur dann gut,
         H = H*360/(2.7*PI);              //wenn die Winkel verschieden sind
         rueckgabe = color(H,255,255);    
         break; 
      }   
      zAlt = zNeu; 
      n++;
    }
 //end of while---------------------------------------------------------------------  
   return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color newtonJulia(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    trapped = false;
    zAlt = Z0;
  
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = FPNewton(zAlt); 
      abstand =(zNeu.subtractC(zAlt)).getLength();
      laenge = zNeu.getLength();
      if(abstand <1e-10){
         float H = (float)zNeu.getAngle();//funktioniert nur dann gut,
         H = H*360/(2.7*PI);              //wenn die Winkel verschieden sind
         rueckgabe = color(H,255,255);    
         break; 
      }   
      zAlt = zNeu; 
      n++;
    }
 //end of while---------------------------------------------------------------------  
   return rueckgabe;
}
/////////////////////////////////////////////////////////////////////
 Complex FPNewton10(Complex zAlt){//Newton-Iteration zehn mal
 
   for(int i =0; i< 10;i++){
      zNeu = f(zAlt,C).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;//println(zAlt);
   }
  return zAlt;
 }
 
 Complex FPNewton(Complex zAlt){//Newton-Iteration ein mal 
  
      zNeu = f(zAlt,C).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;//println(zAlt);
 
  return zAlt;
 }
 Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(7);//z^7
      zaehler = zaehler.addC(C);//z^7+c 
      zaehler = zaehler.subtractC((zAlt.power(3)).multiply(3));//z^7-3z^3+c 
      zaehler = zaehler.multiply(-1);
      return zaehler;
 }
 Complex fS(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt.power(6);//z^6
      nenner = nenner.multiply(7);//7z^6
      nenner = nenner.subtractC((zAlt.power(2)).multiply(9));
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
/////////////////////////////////////////////////////////////////////
color juliaQuadratTest(Complex Z0, double Dx, double Dy) {
   
    color rueckgabe ;
    
    int fpNummer0 =-1;
    float d = 10;
    int anzahlFP = Fixpunkte.size();
    int n = 0;  
    zAlt = Z0;
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }  
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer0 = i;
    } 
    
//--------------------------------------------------    
    int fpNummer1 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }    
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer1 = i;
    } 
//---------------------------------------------------    
    int fpNummer2 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;        
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer2 = i;
    } 
    
//---------------------------------------------------------   
    int fpNummer3 =-1; 
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);  
        zAlt = zNeu;      
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer3 = i;
    } 
        
   //Rückgabe weiß, wenn höchstens zwei Ecken des Quadrats zum gleichen FP führen
    if(fpNummer0==fpNummer1 && fpNummer1==fpNummer2  ||
       fpNummer0==fpNummer2 && fpNummer2==fpNummer3  ||
       fpNummer0==fpNummer1 && fpNummer1==fpNummer3  ||
       fpNummer1==fpNummer2 && fpNummer2==fpNummer3    ) 
       rueckgabe = color(0);//Pixel weiß: ein, zwei Eckpunkte im Chaos
       else rueckgabe = color(255);                            // d.h. drei oder zwei Eckpunkte im Konvergenzbereich
    
    return rueckgabe;
    
 
 }
////////////////////////////////////////////////////////////////////////////////////
void bild1(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJulia(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild2(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
            
             if(juliaQuadratTest(z0,dx,dy)==color(255)){//Punkt nahe der Julia-Menge
               pg.pixels[i+j*pg.width] = color(0);
             }else{
               pg.pixels[i+j*pg.width] = newtonJulia(z0);   
             }
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild3(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaTrap(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild4(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaTrap(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild5(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             if(juliaQuadratTest(z0,dx,dy)==color(255)){
                pg.pixels[i+j*pg.width] = color(255);//Julia-Fraktal
                
              }else{
                 pg.pixels[i+j*pg.width] = color(0);//Nur Julia-Fraktal sichtbar
              }
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////
void bild6(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaKonvergenz(z0);
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////

}
